/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-react-core/ES2015/DependencyProperty";
import { CategoryHighlightLayerFrame } from "./CategoryHighlightLayerFrame";
import { Type, Base, Number_$type, typeCast, fromEnum, Point_$type, markType, runOn } from "igniteui-react-core/ES2015/type";
import { XamDataChart } from "./XamDataChart";
import { List$1 } from "igniteui-react-core/ES2015/List$1";
import { CategoryHighlightFrameRect } from "./CategoryHighlightFrameRect";
import { Pool$1 } from "igniteui-react-core/ES2015/Pool$1";
import { Rectangle } from "igniteui-react-core/ES2015/Rectangle";
import { PropertyMetadata } from "igniteui-react-core/ES2015/PropertyMetadata";
import { isNaN_, truncate } from "igniteui-react-core/ES2015/number";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { BrushUtil } from "igniteui-react-core/ES2015/BrushUtil";
import { Color } from "igniteui-react-core/ES2015/Color";
export class CategoryHighlightLayer extends AnnotationLayer {
    constructor() {
        super();
        let a = new CategoryHighlightLayerFrame();
        let b = new CategoryHighlightLayerFrame();
        let c = new CategoryHighlightLayerFrame();
        let d = this.fc / 1000;
        this.lq = a;
        this.lp = b;
        this.lr = c;
        this.ab = CategoryHighlightLayer.$;
    }
    bf() {
        return new CategoryHighlightLayerView(this);
    }
    ii(a) {
        super.ii(a);
        this.mr = a;
    }
    get mu() {
        return this.c(CategoryHighlightLayer.m1);
    }
    set mu(a) {
        this.h(CategoryHighlightLayer.m1, a);
    }
    l6(a, b) {
        if (this.mq == null || this.mq == a) {
            if (!this.aq.c) {
                this.i1(b);
            }
        }
    }
    ms(a) {
        return a != null && a.cd();
    }
    l9(a, b) {
        super.l9(a, b);
        let c = a;
        c.g.clear();
        let d = this.mt;
        if (isNaN_(this.mn.x) && isNaN_(this.mn.y)) {
            return;
        }
        if (this.mq != null) {
            if (this.ms(this.mq)) {
                this.mz(this.mq, c, d);
            }
        }
        else {
            if (typeCast(XamDataChart.$, this.bs) !== null) {
                let e = this.bs;
                for (let f of fromEnum(e.axes)) {
                    if (typeCast(CategoryAxisBase.$, f) !== null && this.ms(f)) {
                        this.mz(f, c, d);
                    }
                }
            }
        }
    }
    mz(a, b, c) {
        if (this.bi == null || this.bi.bq.isEmpty || this.bi.bp.isEmpty) {
            return;
        }
        let d = this.mn.x;
        if (a.ce && isNaN_(d)) {
            d = 0;
        }
        d = this.bi.bp.left + this.bi.bp.width * (d - this.bi.bq.left) / this.bi.bq.width;
        let e = this.mn.y;
        if (!a.ce && isNaN_(e)) {
            e = 0;
        }
        e = this.bi.bp.top + this.bi.bp.height * (e - this.bi.bq.top) / this.bi.bq.height;
        let f = a.km({ $type: Point_$type, x: d, y: e }, c, this.mu);
        this.my(f, b, a);
    }
    my(a, b, c) {
        let d = new CategoryHighlightFrameRect();
        d.b = a.left;
        d.e = a.top;
        d.c = a.right;
        d.a = a.bottom;
        d.g = this.ml();
        d.h = this.mm();
        if (d.g == null) {
            d.g = this.mr.b7(c.ia);
        }
        if (d.h == null) {
            d.h = this.mr.b7(c.ia);
        }
        d.d = this.es;
        d.f = Base.getHashCodeStatic(c);
        if (!a.isEmpty) {
            b.g.addItem(d.f, d);
        }
    }
    mc(a, b) {
        super.mc(a, b);
        let c = this.mr.b0;
        let d = a;
        let e = 0;
        for (let f of fromEnum(d.g.values)) {
            let g = c.item(e);
            this.m0(f, g);
            e++;
        }
        c.count = e;
    }
    c5() {
        return true;
    }
    m0(a, b) {
        if (isNaN_(a.b) || isNaN_(a.e) || isNaN_(a.a) || isNaN_(a.c) || isNaN_(a.d)) {
            b._visibility = 1;
            return;
        }
        this.mr.b2(b, a.b, a.e, a.c - a.b, a.a - a.e);
        b._fill = a.g;
        b._stroke = a.h;
        b.ac = a.d;
        if (this.kz != null) {
            b.ai = this.kz;
        }
        else {
            b.ai = null;
        }
        b.ad = this.k0;
    }
    io(a, b, c, d) {
        super.io(a, b, c, d);
        switch (b) {
            case CategoryHighlightLayer.$$p[0]:
                this.i1(true);
                break;
            case CategoryHighlightLayer.$$p[1]:
                this.i1(true);
                break;
        }
    }
}
CategoryHighlightLayer.m1 = DependencyProperty.i("BAndHighlightWidth", Number_$type, CategoryHighlightLayer.$, new PropertyMetadata(2, 10, (a, b) => a.raisePropertyChanged("BAndHighlightWidth", b.oldValue, b.newValue)));
CategoryHighlightLayer.$t = markType(CategoryHighlightLayer, 'CategoryHighlightLayer', AnnotationLayer.$);
Type.dep(DependencyProperty, PropertyMetadata, CategoryHighlightLayer, 'raisePropertyChanged', ['TargetAxis:mq:m2', [CategoryAxisBase.$, null], 'UseInterpolation:mt:m3', [0, false]]);
export class CategoryHighlightLayerView extends AnnotationLayerView {
    constructor(a) {
        super(a);
        this.bz = null;
        this.b0 = null;
        this.b1 = null;
        this.bz = a;
        this.b1 = new List$1(Rectangle.$, 0);
    }
    ap() {
        super.ap();
        this.b0 = ((() => {
            let $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(this, this.b8);
            $ret.activate = runOn(this, this.b3);
            $ret.disactivate = runOn(this, this.b5);
            $ret.destroy = runOn(this, this.b4);
            return $ret;
        })());
    }
    b8() {
        let a = new Rectangle();
        a.ab = false;
        this.b1.add(a);
        return a;
    }
    b3(a) {
        a._visibility = 0;
    }
    b5(a) {
        a._visibility = 1;
    }
    b4(a) {
        this.b1.remove(a);
    }
    b6(a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.h(a, 0.1);
    }
    b7(a) {
        if (a != null) {
            let b = BrushUtil.h(a, 0.3);
            if (b.isGradient) {
                let c = b;
                if (c.gradientStops != null) {
                    for (let d = 0; d < c.gradientStops.length; d++) {
                        let e = c.gradientStops[d];
                        e.color = Color.u(truncate(Math.round((e.color.l) * 0.2)), e.color.o, e.color.n, e.color.m);
                        e.color = e.color;
                    }
                }
            }
            else {
                b.color = Color.u(truncate(Math.round((b.color.l) * 0.2)), b.color.o, b.color.n, b.color.m);
                b.color = b.color;
            }
            return b;
        }
        else {
            return null;
        }
    }
    b2(a, b, c, d, e) {
        a._visibility = 0;
        a.n = b;
        a.o = c;
        a.width = d;
        a.height = e;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d && !b) {
            for (let c = 0; c < this.b1.count; c++) {
                let d = this.b1._inner[c];
                if (d._visibility == 0) {
                    a.v(d);
                }
            }
        }
    }
    ai(a) {
        super.ai(a);
        for (let b = 0; b < this.b1.count; b++) {
            this.e.a2.exportRectangleData(a, this.b1._inner[b], "cihRect", ["Main", "CategoryItem"]);
        }
    }
}
CategoryHighlightLayerView.$t = markType(CategoryHighlightLayerView, 'CategoryHighlightLayerView', AnnotationLayerView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.CategoryHighlightLayer" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.CategoryHighlightLayer" />*/
